#include <stdio.h>
#include "math_vector_operations.h"

float getLength(sF3dVector_t* v)
{
    return (float)(sqrt(SQR(v->x)+SQR(v->y)+SQR(v->z)));

}

void normalize(sF3dVector_t* v)
{
    float l = getLength(v);
	if (l == 0.0f) {
	   v->x = v->y = v->z = 0.0;
       return;
    }
	v->x = v->x / l;
	v->y = v->y / l;
	v->z = v->z / l;
}

void sum (sF3dVector_t* v, sF3dVector_t v2){

    v->x = v->x + v2.x;
    v->y = v->y + v2.y;
    v->z = v->z + v2.z;

}

void difference (sF3dVector_t* v, sF3dVector_t v2){

    v->x = v->x - v2.x;
    v->y = v->y - v2.y;
    v->z = v->z - v2.z;

}

void  float_mul (sF3dVector_t* v, float r){

    v->x = v->x * r;
    v->y = v->y * r;
    v->z = v->z * r;
    
}
void  float_div (sF3dVector_t* v, float r){

    v->x = v->x / r;
    v->y = v->y / r;
    v->z = v->z / r;

}
float dotProduct (sF3dVector_t* v, sF3dVector_t v2){
    return v->x*v2.x + v->y*v2.y + v->z*v2.z;
}

void crossProduct (sF3dVector_t* v, sF3dVector_t v2){
    float vx, vy, vz;
    vx = v->x;
    vy = v->y;
    vz = v->z;    
    v->x = vy*v2.z - vz*v2.y;
    v->y = vz*v2.x - vx*v2.z;
    v->z = vx*v2.y - vy*v2.x;

}


void vector_mul (sF3dMatrix_t m, sF3dVector_t* v){
    float vx, vy, vz;
    vx = v->x;
    vy = v->y;
    vz = v->z;
    v->x = m.x1*vx + m.y1*vy + m.z1*vz;
	v->y = m.x2*vx + m.y2*vy + m.z2*vz;
	v->z = m.x3*vx + m.y3*vy + m.z3*vz;

}
